' Ellipse70.bas for FilmStar DESIGN
' Copyright 2014 FTG Software Associates
'
' Based on FilmSolve0-45.bas
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program calculates the confidence level for reverse synthesis
' according to the following method:
'
' 1. Generate a design with random errors
' 2. Calculate the spectrum and convert to ellipsometric targets at 70
' 3. Restore the original design and solve for layers by optimization
' 4. Pass = all layers within Verification Level = TestPC/100 (default 0.5%)
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Ellipse Solve 70
'   Command       basrun c:\winfilm\basic32\Ellips70.bas;
'

Option Explicit
DefInt i-N
DefSng A-H, O-Z
Option Base 1

Sub Main
    Const Ang = 70
    Dim i, k, IterNG, nLayers, Design0$, qDesign(), qDesc$(), qSolve(), qType$()
    Dim Iter, TestPC, bOK As Boolean
    Iter = Val(InputBox("Enter number of iterations", "Reverse Synthesis Test", "10"))
    TestPC = Val(InputBox("Enter Verification Level in %", "Reverse Synthesis Test", ".5"))
    Interactor = False
    If TestPC > 0 Then
        Angle = Ang
        MainEvents = True   ' enables Abort menu command
        Design0 = Design
        For i = 1 To Iter
            StatusLabel CStr(i) & "/" & CStr(Iter)
            Design = Design0    ' original design
            CalcRand 0, 1       ' randomize layers, retaining randomized design
            DataCopy            ' keep spectrum
            GetLayers nLayers, qDesign(), qType$(), qDesc()
            SpecTargets True, "D", 1, Ang, "R"
            SpecTargets False, "P", 1, Ang, "R"
            Design = Design0    ' restore original design
            Optimize
            GetLayers nLayers, qSolve(), qType$(), qDesc() ' get solution
            Interactor = True
            DataPaste
            Wait 3
            Interactor = False
            bOK = True
            For k = 1 To nLayers
                If Abs(qSolve(k) - qDesign(k))/qDesign(k) > TestPC/100 Then
                    IterNG = IterNG + 1 ' fails
                    bOK = False
                    Exit For
                End If
            Next k
        Next i
        Design = Design0    ' restore original design
        MsgBox "Confidence Level = " & CStr(100*(Iter - IterNG)/Iter) & "%", vbInformation, "Inverse Synthesis 70"
    End If
    LineColor "R"
End Sub
