' Sub RandStackThickIndex.bas
' Random analysis varying physical thickness and index
' Note: Specify single color in FSPlot Module
Option Explicit
Const nIter% = 100
Const SdThkPC! = 0       ' % Thickness StdDev
Const SdThick! = 0       ' Thickness StdDev (nm)
Const SdInxPC! = 1       ' % Index StdDev
Const vIndex! = 100      ' Default value

Sub Main
    Dim i%, iter%
    PlotClose
    GraphSetup
    PlotActivate
    Dim q0!(NumLayers)
    For i = 1 To NumLayers  ' Save original design
        q0(i) = CSng(StackIndex(i + 2, "Thick"))
    Next i
    For iter = 1 To nIter
        For i = 1 To NumLayers
            If SdThkPC > 0 Then     ' % thickness errors
                StackIndexSet i + 2, "Thick", q0(i) * (1 + .01*SdThkPC*RndNorm)
            Else    ' absolute thickness errors
                StackIndexSet i + 2, "Thick", q0(i) + SdThick*RndNorm
            End If
            If i Mod 2 = 1 Then  ' TiO2 layers in Laser-O-Func.faw
                StackIndexSet i + 2, "A", vIndex * (1 + .01 * SdInxPC*RndNorm)
            End If
        Next i
        Calculate
        PlotNext
    Next iter
    ' Restore original Stack Editor design
    For i = 1 To NumLayers
        StackIndexSet i + 2, "Thick", q0(i)
        If i Mod 2 = 1 Then  ' TiO2 layers in Laser-O-Func.faw
            StackIndexSet i + 2, "A", vIndex   ' Restore default value
        End If
    Next i
End Sub

Sub GraphSetup
' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 9269832, 101128, 0
    PlotSize 8445, 6360, 86
    PlotTitleFont = "Arial"
    PlotTitleSize = 110
    PlotLegendSize = 110
    PlotLegendSimple = False
    PlotAxesFont = "Arial"
    PlotAxesLabelSize = 110
    PlotAxesNumberSize = 110
    PlotFontFixed = False
    PlotFontFixedSize = 2
    PlotAxesConfig = 0
    PlotEdgeSpace 75, -20, 30, 0
    PlotAxesSpace .15, .25, .5, 3
    PlotColors "255, 16711680, 65280, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    PlotBitmapMode = True

    PlotBitmap(1) = ""
    PlotBitmap(2) = ""
    PlotBitmapType = 1
    PlotBitmapColors 13434828, 12648447, 12648447, 11513775, 986895, 32896
    PlotTableColors 16777215, 0, 0, 0
End Sub
